import QtQuick 2.15
import QtQuick.Controls 2.15
import Qt.labs.folderlistmodel 2.15
import QtQml 2.15


GridView {
    width: 300
    height: 300
    cellWidth: 100
    cellHeight: 100

    ScrollBar.vertical: ScrollBar {
        policy: ScrollBar.AlwaysOn
    }

    model: FolderListModel {
        id: folderListModel
        showDirs: false
        folder: switch (Qt.platform.os) {
                case "osx": return "file://" + effectImagesDir
                case "windows": return "file:///" + effectImagesDir
                }
        nameFilters: ["*.bmp"]
    }

    SystemPalette { id: activePalette }

    highlight: Rectangle { color: activePalette.highlight }

    delegate: Item {
        width: 100
        height: 100

        Image {
            id: effectIcon
            source: folderListModel.folder + "/" + fileName
            anchors.centerIn: parent
            width: parent.width - 10
            height: parent.height - 10
            smooth: true
            fillMode: Image.Stretch
        }

        MouseArea {
            id: mouseArea
            anchors.fill: parent
            onClicked: {
                parent.GridView.view.currentIndex = index
                currentImageHandler.onCurrentImageEffectChanged(effectIcon.source)
            }
            drag.target: effectIcon
        }

        Drag.active: mouseArea.drag.active
        Drag.mimeData: { "text/plain": effectIcon.source }
        Drag.dragType: Drag.Automatic
        Drag.imageSource: "qrc:/icons/green-picture.png"
        Drag.hotSpot.x: 10
        Drag.hotSpot.y: 10
    }
}
